/* 
 * This plug-in is needed to block transition
 * for the specific team, for players who listed in
 * the configuration file.
 * 
 * CREDITS:
 * 1. VEN. Thanks for plug-in Auto Join on Connect
 * 2. Thanks to members of the forum AMX-X.RU, especially many thanks PRoSToTeM@
*/

#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

#if AMXX_VERSION_NUM < 183
    #include <colorchat>
#endif

#pragma semicolon 1

enum {
    SHOWTEAMSELECT = 3,
    VGUI_MENU_ID = 2,
    CELLSIZE_BUFFER = 64,
    CELLSIZE_VARIABLE = 32,
    Menu_ChooseTeam = 1,
    m_iJoiningState = 121,
    m_iMenu = 205    
};

#define PLUGIN "Block Join"
#define VERSION "1.0"
#define AUTHOR "NanoDesu^^"

#define CLASS_JOIN "5"

#define MAX_PLAYERS 32

#define PREFIX_TO_USER_MESSAGE "BlockJoin"
#define USER_MESSAGE "You were not allowed to move from team to team"//message to user

#define FILE "/addons/amxmodx/configs/blockjoin/users.ini"//configuration file

new HamHook:gHamPreThink;

new Trie: gFileDate, 
gPlayerDate[MAX_PLAYERS + 1], gPlayerKey[MAX_PLAYERS], 
iMsgMenu[2];

public plugin_precache() {
    gFileDate = TrieCreate();
    
    static iFile; iFile = fopen(FILE, "rt");
    
    if (!iFile)
        return 0;
    
    static szBufferFile[CELLSIZE_BUFFER], szBufferData[CELLSIZE_VARIABLE], szBufferKey[CELLSIZE_VARIABLE];
    
    while(!feof(iFile)) {
        fgets(iFile, szBufferFile, charsmax( szBufferFile ));
        
        trim(szBufferFile);
        
        if(szBufferFile[0] == ';' || !szBufferFile[0])
            continue;
        
        parse(szBufferFile, szBufferData, charsmax( szBufferData ), szBufferKey, charsmax( szBufferKey ));
        
        remove_quotes(szBufferData); remove_quotes(szBufferKey);
        TrieSetString(gFileDate, szBufferData, szBufferKey);
    }
    
    fclose(iFile);
    
    return 2;
}

public plugin_init() {
    register_plugin(PLUGIN, VERSION, AUTHOR);
    
    iMsgMenu[0] = get_user_msgid("VGUIMenu");
    iMsgMenu[1] = get_user_msgid("ShowMenu");
    
    register_message(iMsgMenu[1], "fwMessageHandlerMenu");
    register_message(iMsgMenu[0], "fwMessageHandlerMenu");
    
    gHamPreThink = RegisterHam(Ham_Player_PreThink, "player", "fwPlayerPreThink_Post", true);
    
    register_clcmd("chooseteam", "CmdHandler");
    register_clcmd("jointeam", "CmdHandler");
    
    DisableHamForward(gHamPreThink);
}

public client_authorized(iPlayer) {
    static szPlayerName[CELLSIZE_VARIABLE]; get_user_name(iPlayer, szPlayerName, charsmax( szPlayerName ));
    
    if(TrieKeyExists(gFileDate, szPlayerName)) {
        gPlayerDate[iPlayer] = true;
        TrieGetString(gFileDate, szPlayerName, gPlayerKey, charsmax( gPlayerKey ));
    }
    else {
        static szPlayerSteam[CELLSIZE_VARIABLE]; get_user_authid(iPlayer, szPlayerSteam, charsmax( szPlayerSteam ));
        if (!gPlayerDate[iPlayer] && TrieKeyExists(gFileDate, szPlayerSteam)) {
            gPlayerDate[iPlayer] = true;
            TrieGetString(gFileDate, szPlayerSteam, gPlayerKey, charsmax( gPlayerKey ));
        }
        else {
            static szPlayerIp[CELLSIZE_VARIABLE]; get_user_ip(iPlayer, szPlayerIp, charsmax( szPlayerIp ), 1);
            if (!gPlayerDate[iPlayer] && TrieKeyExists(gFileDate, szPlayerIp)) {
                gPlayerDate[iPlayer] = true;
                TrieGetString(gFileDate, szPlayerIp, gPlayerKey, charsmax( gPlayerKey ));
            }
        }
    }
}

public CmdHandler(iPlayer) {
    if(gPlayerDate[iPlayer]) {
        client_print_color (iPlayer, print_team_default, "^x04[%s]^x01 %s", PREFIX_TO_USER_MESSAGE, USER_MESSAGE);
        return 2;
    }
		
    return 0;
}

public client_disconnect(iPlayer)
    return gPlayerDate[iPlayer] = false;

public fwMessageHandlerMenu(iMsgID, iDest, iPlayer) {
    if (!gPlayerDate[iPlayer])
        return 0;
    
    if (iMsgID == iMsgMenu[0]) {
        if (get_msg_arg_int(1) != VGUI_MENU_ID || get_msg_arg_int(2) & MENU_KEY_0)
            return 0;
    }
    else {    
        static szMessageSelected[] = "#Team_Select"; static szMessageMenu[sizeof( szMessageSelected )];
        get_msg_arg_string(4, szMessageMenu, charsmax( szMessageMenu ));

        if (!equal(szMessageMenu, szMessageSelected))
            return 0;
    }
    
    if (get_pdata_int(iPlayer, m_iMenu) == Menu_ChooseTeam || get_pdata_int(iPlayer, m_iJoiningState) != SHOWTEAMSELECT)
        return 0;

    EnableHamForward(gHamPreThink);

    return 1;
}

public fwPlayerPreThink_Post(iPlayer) {
    DisableHamForward(gHamPreThink);

    static iOldShowMenuBlock;iOldShowMenuBlock = get_msg_block(iMsgMenu[1]);
    static iOldVGUIMenuBlock;iOldShowMenuBlock = get_msg_block(iMsgMenu[0]);
    
    set_msg_block(iMsgMenu[1], BLOCK_SET);
    set_msg_block(iMsgMenu[0], BLOCK_SET);
    engclient_cmd(iPlayer, "jointeam", gPlayerKey);
    engclient_cmd(iPlayer, "joinclass", CLASS_JOIN);
    set_msg_block(iMsgMenu[0], iOldVGUIMenuBlock);
    set_msg_block(iMsgMenu[1], iOldShowMenuBlock);
}

public plugin_end()
    TrieDestroy(gFileDate);